#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -*- Python -*-

"""
 @file kobukiMongoInsert.py
 @brief ModuleDescription
 @date $Date$


"""
import sys
import time
from datetime import datetime
sys.path.append(".")

# Import RTM module
import RTC
import OpenRTM_aist 
import pymongo

# Import Service implementation class
# <rtc-template block="service_impl">

# </rtc-template>

# Import Service stub modules
# <rtc-template block="consumer_import">
# </rtc-template>


# This module's spesification
# <rtc-template block="module_spec">
kobukimongoinsert_spec = ["implementation_id", "kobukiMongoInsert", 
		 "type_name",         "kobukiMongoInsert", 
		 "description",       "ModuleDescription", 
		 "version",           "1.0.0", 
		 "vendor",            "University of Aizu", 
		 "category",          "Category", 
		 "activity_type",     "STATIC", 
		 "max_instance",      "1", 
		 "language",          "Python", 
		 "lang_type",         "SCRIPT",
		 "conf.default.collection_name", "kobuki_collection",
		 "conf.default.db_IP", "localhost",
		 "conf.default.db_Port", "27017",

		 "conf.__widget__.collection_name", "text",
		 "conf.__widget__.db_IP", "text",
		 "conf.__widget__.db_Port", "text",

         "conf.__type__.collection_name", "string",
         "conf.__type__.db_IP", "string",
         "conf.__type__.db_Port", "int",

		 ""]
# </rtc-template>

##
# @class kobukiMongoInsert
# @brief ModuleDescription
# 
# 
class kobukiMongoInsert(OpenRTM_aist.DataFlowComponentBase):
	
	##
	# @brief constructor
	# @param manager Maneger Object
	# 
	def __init__(self, manager):
		OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)

		out_arg = [None] * ((len(RTC._d_TimedPose2D) - 4) / 2)
		self._d_out = RTC.TimedPose2D(*out_arg)
		"""
		"""
		self._outIn = OpenRTM_aist.InPort("out", self._d_out)
		battery_arg = [None] * ((len(RTC._d_TimedDouble) - 4) / 2)
		self._d_battery = RTC.TimedDouble(*battery_arg)
		"""
		"""
		self._batteryIn = OpenRTM_aist.InPort("battery", self._d_battery)
		bumper_arg = [None] * ((len(RTC._d_TimedBooleanSeq) - 4) / 2)
		self._d_bumper = RTC.TimedBooleanSeq(*bumper_arg)
		"""
		"""
		self._bumperIn = OpenRTM_aist.InPort("bumper", self._d_bumper)


		


		# initialize of configuration-data.
		# <rtc-template block="init_conf_param">
		"""
		
		 - Name:  collection_name
		 - DefaultValue: kobuki_collection
		"""
		self._collection_name = ['kobuki_collection']
		"""
		
		 - Name:  db_IP
		 - DefaultValue: localhost
		"""
		self._db_IP = ["localhost"]
		"""
		
		 - Name:  db_Port
		 - DefaultValue: 27017
		"""
		self._db_Port = ["27017"]
		
		# </rtc-template>


		 
	##
	#
	# The initialize action (on CREATED->ALIVE transition)
	# formaer rtc_init_entry() 
	# 
	# @return RTC::ReturnCode_t
	# 
	#
	def onInitialize(self):
		print "start onInitialize"
		# Bind variables and configuration variable
		self.bindParameter("collection_name", self._collection_name, "kobuki_collection")
		self.bindParameter("db_IP", self._db_IP, "localhost")
		self.bindParameter("db_Port", self._db_Port, "27017")
		# Set InPort buffers
		self.addInPort("out",self._outIn)
		self.addInPort("battery",self._batteryIn)
		self.addInPort("bumper",self._bumperIn)
		# Set OutPort buffers
		
		# Set service provider to Ports
		
		# Set service consumers to Ports
		
		# Set CORBA Service Ports
		print "Initialize Success!"
		return RTC.RTC_OK
	
	#	##
	#	# 
	#	# The finalize action (on ALIVE->END transition)
	#	# formaer rtc_exiting_entry()
	#	# 
	#	# @return RTC::ReturnCode_t
	#
	#	# 
	#def onFinalize(self):
	#
	#	return RTC.RTC_OK
	
	#	##
	#	#
	#	# The startup action when ExecutionContext startup
	#	# former rtc_starting_entry()
	#	# 
	#	# @param ec_id target ExecutionContext Id
	#	#
	#	# @return RTC::ReturnCode_t
	#	#
	#	#
	#def onStartup(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#	##
	#	#
	#	# The shutdown action when ExecutionContext stop
	#	# former rtc_stopping_entry()
	#	#
	#	# @param ec_id target ExecutionContext Id
	#	#
	#	# @return RTC::ReturnCode_t
	#	#
	#	#
	#def onShutdown(self, ec_id):
	#
	#	return RTC.RTC_OK
	
		##
		#
		# The activated action (Active state entry action)
		# former rtc_active_entry()
		#
		# @param ec_id target ExecutionContext Id
		# 
		# @return RTC::ReturnCode_t
		#
		#
	def onActivated(self, ec_id):
		print "start onActivated"
		print self._db_IP[0],self._db_Port[0]
		self.client = pymongo.MongoClient(self._db_IP[0],int(self._db_Port[0]))
		print "collection name ->",self._collection_name[0]
		self.db = self.client[self._collection_name[0]]
		self.co = self.db[self._collection_name[0]]
		print "onActivated Success!"
		return RTC.RTC_OK
	
	#	##
	#	#
	#	# The deactivated action (Active state exit action)
	#	# former rtc_active_exit()
	#	#
	#	# @param ec_id target ExecutionContext Id
	#	#
	#	# @return RTC::ReturnCode_t
	#	#
	#	#
	#def onDeactivated(self, ec_id):
	#
	#	return RTC.RTC_OK
	
		##
		#
		# The execution action that is invoked periodically
		# former rtc_active_do()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onExecute(self, ec_id):
		print self._db_IP[0],self._db_Port[0]
		print "collection name ->",self._collection_name[0]
		print "start onExecute"
		isDataIn = False
		kv = {}
		print "test1"
		dt = datetime.now()
		print "test2"
		kv.setdefault("systemTime", dt.strftime("%Y/%m/%d %H:%M:%S.%f"))
		print "setting systemTime OK"
		if self._outIn.isNew():
			isDataIn = True
			print "out data in",self._outIn.read()
			kv.setdefault("out", toMongoTimedPose2D(self._outIn.read()))
		if self._batteryIn.isNew():
			print "battery data in"
			isDataIn = True
			kv.setdefault("battery", toMongoTimedDouble(self._batteryIn.read()))
		if self._bumperIn.isNew():
			print "bumper data in"
			isDataIn = True
			kv.setdefault("bumper",toMongoTimedBooleanSeq(self._bumperIn.read()))
		if isDataIn:
			print "test mousugu",kv
			self.co.insert_one(kv)
			print "test omaeka"
		print "onExecute Success!"
		return RTC.RTC_OK
	
def toMongoTimedPose2D(dt):
	print "toMongoTimedPose2D"
	kv = {"time":[dt.tm.sec, dt.tm.nsec],"Pose2D":[dt.data.position.x,dt.data.position.y]}
	
	print "dt.tm.sec",datetime.fromtimestamp(dt.tm.sec).strftime('%Y/%m/%d %H:%M:%S')+("%.4F" % (float(dt.tm.nsec) / 10**9))[1:]
	print "dt.tm.nsec",dt.tm.nsec,dt.tm,dt,float(dt.tm.nsec)
	print dt.tm
	print "end function"
	return kv
def toMongoTimedDouble(dt):
	kv = {"time":[dt.tm.sec, dt.tm.nsec],"Double":dt.data}
	return kv
def toMongoTimedBooleanSeq(dt):
	kv = {"time":[dt.tm.sec, dt.tm.nsec],"BooleanSeq":dt.data}
	return kv
	#	##
	#	#
	#	# The aborting action when main logic error occurred.
	#	# former rtc_aborting_entry()
	#	#
	#	# @param ec_id target ExecutionContext Id
	#	#
	#	# @return RTC::ReturnCode_t
	#	#
	#	#
	#def onAborting(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#	##
	#	#
	#	# The error action in ERROR state
	#	# former rtc_error_do()
	#	#
	#	# @param ec_id target ExecutionContext Id
	#	#
	#	# @return RTC::ReturnCode_t
	#	#
	#	#
	#def onError(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#	##
	#	#
	#	# The reset action that is invoked resetting
	#	# This is same but different the former rtc_init_entry()
	#	#
	#	# @param ec_id target ExecutionContext Id
	#	#
	#	# @return RTC::ReturnCode_t
	#	#
	#	#
	#def onReset(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#	##
	#	#
	#	# The state update action that is invoked after onExecute() action
	#	# no corresponding operation exists in OpenRTm-aist-0.2.0
	#	#
	#	# @param ec_id target ExecutionContext Id
	#	#
	#	# @return RTC::ReturnCode_t
	#	#

	#	#
	#def onStateUpdate(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#	##
	#	#
	#	# The action that is invoked when execution context's rate is changed
	#	# no corresponding operation exists in OpenRTm-aist-0.2.0
	#	#
	#	# @param ec_id target ExecutionContext Id
	#	#
	#	# @return RTC::ReturnCode_t
	#	#
	#	#
	#def onRateChanged(self, ec_id):
	#
	#	return RTC.RTC_OK
	



def kobukiMongoInsertInit(manager):
    profile = OpenRTM_aist.Properties(defaults_str=kobukimongoinsert_spec)
    manager.registerFactory(profile,
                            kobukiMongoInsert,
                            OpenRTM_aist.Delete)

def MyModuleInit(manager):
    kobukiMongoInsertInit(manager)

    # Create a component
    comp = manager.createComponent("kobukiMongoInsert")

def main():
	mgr = OpenRTM_aist.Manager.init(sys.argv)
	mgr.setModuleInitProc(MyModuleInit)
	mgr.activateManager()
	mgr.runManager()

if __name__ == "__main__":
	main()

