#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -*- Python -*-
# edit yukinori
"""
 @file kinectInsert.py
 @brief ModuleDescription
 @date $Date$


"""
from pykinect2 import PyKinectV2
from pykinect2.PyKinectV2 import *
from pykinect2 import PyKinectRuntime

import ctypes
import _ctypes
import pygame

import sys
import time
sys.path.append(".")

# Import RTM module
import RTC
import OpenRTM_aist
import numpy as np

if sys.hexversion >= 0x3000000:
	import _thread as thread
else:
	import thread
# Import Service implementation class
# <rtc-template block="service_impl">

# </rtc-template>

# Import Service stub modules
# <rtc-template block="consumer_import">
# </rtc-template>


# This module's spesification
# <rtc-template block="module_spec">
kinectinsert_spec = ["implementation_id", "kinectInsert", 
		 "type_name",         "kinectInsert", 
		 "description",       "ModuleDescription", 
		 "version",           "1.1.2", 
		 "vendor",            "University of Aizu", 
		 "category",          "Category", 
		 "activity_type",     "STATIC", 
		 "max_instance",      "1", 
		 "language",          "Python", 
		 "lang_type",         "SCRIPT",
		 ""]
# </rtc-template>

##
# @class kinectInsert
# @brief ModuleDescription
# 
# 
class kinectInsert(OpenRTM_aist.DataFlowComponentBase):
	
	##
	# @brief constructor
	# @param manager Maneger Object
	# 
	def __init__(self, manager):
		OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)
		# initialize of configuration-data.
		# <rtc-template block="init_conf_param">
		
		# </rtc-template>


		 
	##
	#
	# The initialize action (on CREATED->ALIVE transition)
	# formaer rtc_init_entry() 
	# 
	# @return RTC::ReturnCode_t
	# 
	#
	def onInitialize(self):
		# Bind variables and configuration variable
		
		# Set InPort buffers
		
		# Set OutPort buffers
		self._d_skeleton = RTC.TimedFloatSeq(RTC.Time(0,0),[])
		self._skeletonOut = OpenRTM_aist.OutPort("skeleton", self._d_skeleton)
		self.addOutPort("skeleton",self._skeletonOut)
		print "runtime ok"
		# Set service provider to Ports
		
		# Set service consumers to Ports
		
		# Set CORBA Service Ports
		
		return RTC.RTC_OK
	
	def onShutdown(self, ec_id):
		self._kinect.close()
		pygame.quit()
		return RTC.RTC_OK
	def onActivated(self, ec_id):
		pygame.init()
		print "pygame init"
		self._infoObject = pygame.display.Info()
		self._screen = pygame.display.set_mode((self._infoObject.current_w >> 1, self._infoObject.current_h >> 1),pygame.HWSURFACE|pygame.DOUBLEBUF|pygame.RESIZABLE, 32)
		pygame.display.set_caption("Kinect insert")
		self._done = False
		print "time clock"
		self._clock = pygame.time.Clock()
		self._kinect = PyKinectRuntime.PyKinectRuntime(PyKinectV2.FrameSourceTypes_Color | PyKinectV2.FrameSourceTypes_Body)
		self._frame_surface = pygame.Surface((self._kinect.color_frame_desc.Width,self._kinect.color_frame_desc.Height),0,32)
		self._bodies = None
	
		return RTC.RTC_OK
	
	def onExecute(self, ec_id):
		print "START <onExecute>"
		for event in pygame.event.get():
			if event.type == pygame.QUIT:
				self._done = True
			elif event.type == pygame.VIDEORESIZE:
				self._screen = pygame.display.set_mode(event.dict['size'], pygame.HWSURFACE|pygame.DOUBLEBUF|pygame.RESIZABLE, 32)
		if self._kinect.has_new_color_frame():
			print "DEBUG enter <IF STATE> self._kinect.has_new_color_frame"
			frame = self._kinect.get_last_color_frame()
			#self.draw_color_frame(frame, self._frame_surface)
			frame = None
		if self._kinect.has_new_body_frame():
			print "DEBUG enter <IF STATE> self._kinect.has_new_body_frame"
			self._bodies = self._kinect.get_last_body_frame()
		if self._bodies is not None:
			print "DEBUG enter <IF STATE> self.bodies is not"
			for i in range(0, self._kinect.max_body_count):
				#for body in self._bodies.bodies:
				print self._bodies				#print body
				body = self._bodies.bodies[i]
				#print i
				#i += 1
				if not body.is_tracked:
					#print ""
					continue
			
				joints = body.joints
				print list(joints[1])
				print joints
				joint_points = self._kinect.body_joints_to_color_space(joints)
				print joint_points
				#	self.draw_body(joints, joint_points, SKELETON_COLORS[i]))
				print float(joints[1]._CameraSpacePoint.x)
				print joint_points[i],
				#print float(joint_points[i].y),
				#print float(joint_points[i].z),joints
				self._d_skeleton.data.extend([joint_points.x,joint_points.y,joint_points.z])
				print(self._d_skeleton.data)
				time.sleep(0.5)
				#self._d_skeleton.data.append(joint_points.y)
				#self._d_skeleton.data.append(joint_points.z)
        
		#self._skeletonOut.write()
		for i in range(len(self._d_skeleton.data)):
			print self._d_skeleton.data[i]
		print "write() done"
		h_to_w = float(self._frame_surface.get_height()) / self._frame_surface.get_width()
		target_height = int(h_to_w * self._screen.get_width())
		surface_to_draw = pygame.transform.scale(self._frame_surface, (self._screen.get_width(), target_height));
		self._screen.blit(surface_to_draw, (0,0))
		surface_to_draw = None
		pygame.display.update()
		print "display update"
		pygame.display.flip()
		print "display flip"
		#self._clock.tick(120)	
		print "END onExecute"
		return RTC.RTC_OK


	def draw_color_frame(self, frame, target_surface):
		target_surface.lock()
		address = self._kinect.surface_as_array(target_surface.get_buffer())
		ctypes.memmove(address, frame.ctypes.data, frame.size)
		del address
		target_surface.unlock()

def kinectInsertInit(manager):
    profile = OpenRTM_aist.Properties(defaults_str=kinectinsert_spec)
    manager.registerFactory(profile,
                            kinectInsert,
                            OpenRTM_aist.Delete)

def MyModuleInit(manager):
    kinectInsertInit(manager)

    # Create a component
    comp = manager.createComponent("kinectInsert")
def main():
	mgr = OpenRTM_aist.Manager.init(sys.argv)
	print "manager init"
	mgr.setModuleInitProc(MyModuleInit)
	print "set Module init proc"
	mgr.activateManager()
	print "activate manager"
	mgr.runManager()
	print "runmanager"

if __name__ == "__main__":
	main()

