#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -*- Python -*-

"""
 @file testNavio.py
 @brief ModuleDescription
 @date $Date$


"""
import sys
import time
sys.path.append(".")
from datetime import datetime
# Import RTM module
import RTC
import OpenRTM_aist
import pymongo


# Import Service implementation class
# <rtc-template block="service_impl">

# </rtc-template>

# Import Service stub modules
# <rtc-template block="consumer_import">
# </rtc-template>


# This module's spesification
# <rtc-template block="module_spec">
testnavio_spec = ["implementation_id", "testNavio", 
         "type_name",         "testNavio", 
         "description",       "ModuleDescription", 
         "version",           "1.0.0", 
         "vendor",            "VenderName", 
         "category",          "Category", 
         "activity_type",     "STATIC", 
         "max_instance",      "1", 
         "language",          "Python", 
         "lang_type",         "SCRIPT",
         "conf.default.db_IP", "localhost",
         "conf.default.db_Port", "27017",
         "conf.default.db_CollectionName", "my_collection",

         "conf.__widget__.db_IP", "text",
         "conf.__widget__.db_Port", "text",
         "conf.__widget__.db_CollectionName", "text",

         "conf.__type__.db_IP", "string",
         "conf.__type__.db_Port", "int",
         "conf.__type__.db_CollectionName", "string",

         ""]
# </rtc-template>

##
# @class testNavio
# @brief ModuleDescription
# 
# 
class testNavio(OpenRTM_aist.DataFlowComponentBase):
    
    ##
    # @brief constructor
    # @param manager Maneger Object
    # 
    def __init__(self, manager):
        OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)

        Temp_arg = [None] * ((len(RTC._d_TimedFloat) - 4) / 2)
        self._d_Temp = RTC.TimedFloat(*Temp_arg)
        """
        """
        self._TempIn = OpenRTM_aist.InPort("Temp", self._d_Temp)
        Baro_arg = [None] * ((len(RTC._d_TimedFloat) - 4) / 2)
        self._d_Baro = RTC.TimedFloat(*Baro_arg)
        """
        """
        self._BaroIn = OpenRTM_aist.InPort("Baro", self._d_Baro)
        IMU_arg = [None] * ((len(RTC._d_TimedFloatSeq) - 4) / 2)
        self._d_IMU = RTC.TimedFloatSeq(*IMU_arg)
        """
        """
        self._IMUIn = OpenRTM_aist.InPort("IMU", self._d_IMU)
        GPS_arg = [None] * ((len(RTC._d_GPSData) - 4) / 2)
        self._d_GPS = RTC.GPSData(*GPS_arg)
        """
        """
        self._GPSIn = OpenRTM_aist.InPort("GPS", self._d_GPS)


        


        # initialize of configuration-data.
        # <rtc-template block="init_conf_param">
        """
        
         - Name:  db_IP
         - DefaultValue: localhost
        """
        self._db_IP = ['localhost']
        """
        
         - Name:  db_Port
         - DefaultValue: 27017
        """
        self._db_Port = [27017]
        """
        
         - Name:  db_CollectionName
         - DefaultValue: my_collection
        """
        self._db_CollectionName = ['my_collection']
        
        # </rtc-template>


         
    ##
    #
    # The initialize action (on CREATED->ALIVE transition)
    # formaer rtc_init_entry() 
    # 
    # @return RTC::ReturnCode_t
    # 
    #
    def onInitialize(self):
        # Bind variables and configuration variable
        self.bindParameter("db_IP", self._db_IP, "localhost")
        self.bindParameter("db_Port", self._db_Port, "27017")
        self.bindParameter("db_CollectionName", self._db_CollectionName, "my_collection")
        
        # Set InPort buffers
        self.addInPort("Temp",self._TempIn)
        self.addInPort("Baro",self._BaroIn)
        self.addInPort("IMU",self._IMUIn)
        self.addInPort("GPS",self._GPSIn)
        
        # Set OutPort buffers
        
        # Set service provider to Ports
        
        # Set service consumers to Ports
        
        # Set CORBA Service Ports
        
        return RTC.RTC_OK
    
    #	##
    #	# 
    #	# The finalize action (on ALIVE->END transition)
    #	# formaer rtc_exiting_entry()
    #	# 
    #	# @return RTC::ReturnCode_t
    #
    #	# 
    #def onFinalize(self):
    #
    #	return RTC.RTC_OK
    
    #	##
    #	#
    #	# The startup action when ExecutionContext startup
    #	# former rtc_starting_entry()
    #	# 
    #	# @param ec_id target ExecutionContext Id
    #	#
    #	# @return RTC::ReturnCode_t
    #	#
    #	#
    #def onStartup(self, ec_id):
    #
    #	return RTC.RTC_OK
    
    #	##
    #	#
    #	# The shutdown action when ExecutionContext stop
    #	# former rtc_stopping_entry()
    #	#
    #	# @param ec_id target ExecutionContext Id
    #	#
    #	# @return RTC::ReturnCode_t
    #	#
    #	#
    #def onShutdown(self, ec_id):
    #
    #	return RTC.RTC_OK
    
        ##
        #
        # The activated action (Active state entry action)
        # former rtc_active_entry()
        #
        # @param ec_id target ExecutionContext Id
        # 
        # @return RTC::ReturnCode_t
        #
        #
    def onActivated(self, ec_id):
        self.client = pymongo.MongoClient(self._db_IP[0], int(self._db_Port[0]))
        self.db = self.client[self._db_CollectionName[0]]
        self.co = self.db[self._db_CollectionName[0]]
        return RTC.RTC_OK
    
    #	##
    #	#
    #	# The deactivated action (Active state exit action)
    #	# former rtc_active_exit()
    #	#
    #	# @param ec_id target ExecutionContext Id
    #	#
    #	# @return RTC::ReturnCode_t
    #	#
    #	#
    #def onDeactivated(self, ec_id):
    #
    #	return RTC.RTC_OK
    
        ##
        #
        # The execution action that is invoked periodically
        # former rtc_active_do()
        #
        # @param ec_id target ExecutionContext Id
        #
        # @return RTC::ReturnCode_t
        #
        #
    def onExecute(self, ec_id):
        isDataIn = False
        kv = dict()
        dt = datetime.now()
        kv.setdefault("systemTime", dt.strftime("%Y/%m/%d %H:%M:%S.%f"))
        if self._TempIn.isNew():
            tmp1 = self._TempIn.read()
            isDataIn = True
            kv.setdefault("Temp", toMongoTimedFloat(tmp1))
                    #print "Temp: ", tmp1
        if self._BaroIn.isNew():
            tmp2 = self._BaroIn.read()
            isDataIn = True
            kv.setdefault("Baro", toMongoTimedFloat(tmp2))
                    #print "Baro: ", tmp2
        if self._IMUIn.isNew():
            tmp3 = self._IMUIn.read()
            isDataIn = True
            kv.setdefault("IMU", toMongoTimedFloatSeq(tmp3))
                    #print tmp3
        if self._GPSIn.isNew():
            tmp4 = self._GPSIn.read()
            isDataIn = True
            kv.setdefault("GPS", toMongoGPSData(tmp4))
        if isDataIn:
            self.co.insert_one(kv)
        return RTC.RTC_OK
    
    #	##
    #	#
    #	# The aborting action when main logic error occurred.
    #	# former rtc_aborting_entry()
    #	#
    #	# @param ec_id target ExecutionContext Id
    #	#
    #	# @return RTC::ReturnCode_t
    #	#
    #	#
    #def onAborting(self, ec_id):
    #
    #	return RTC.RTC_OK
    
    #	##
    #	#
    #	# The error action in ERROR state
    #	# former rtc_error_do()
    #	#
    #	# @param ec_id target ExecutionContext Id
    #	#
    #	# @return RTC::ReturnCode_t
    #	#
    #	#
    #def onError(self, ec_id):
    #
    #	return RTC.RTC_OK
    
    #	##
    #	#
    #	# The reset action that is invoked resetting
    #	# This is same but different the former rtc_init_entry()
    #	#
    #	# @param ec_id target ExecutionContext Id
    #	#
    #	# @return RTC::ReturnCode_t
    #	#
    #	#
    #def onReset(self, ec_id):
    #
    #	return RTC.RTC_OK
    
    #	##
    #	#
    #	# The state update action that is invoked after onExecute() action
    #	# no corresponding operation exists in OpenRTm-aist-0.2.0
    #	#
    #	# @param ec_id target ExecutionContext Id
    #	#
    #	# @return RTC::ReturnCode_t
    #	#

    #	#
    #def onStateUpdate(self, ec_id):
    #
    #	return RTC.RTC_OK
    
    #	##
    #	#
    #	# The action that is invoked when execution context's rate is changed
    #	# no corresponding operation exists in OpenRTm-aist-0.2.0
    #	#
    #	# @param ec_id target ExecutionContext Id
    #	#
    #	# @return RTC::ReturnCode_t
    #	#
    #	#
    #def onRateChanged(self, ec_id):
    #
    #	return RTC.RTC_OK
def toMongoGPSData(dt):
    kv = {"time": [dt.tm.sec, dt.tm.nsec], "gpsTime": [dt.timeFromGPS.sec, dt.timeFromGPS.msec], "latitude": dt.latitude, "longitude": dt.longitude, "altitude": dt.altitude, "horizontalError": dt.horizontalError, "verticalError": dt.verticalError, "heading": dt.heading, "horizontalSpeed": dt.horizontalSpeed, "verticalSpeed": dt.verticalSpeed, "numSatellites": dt.numSatellites}
    return kv

def toMongoTimedFloatSeq(dt):
    kv = {"time": [dt.tm.sec, dt.tm.nsec],"floatSequence": dt.data}
    return kv

def toMongoTimedFloat(dt):	
    kv = {"time": [dt.tm.sec, dt.tm.nsec],"float": dt.data}
    return kv


def testNavioInit(manager):
    profile = OpenRTM_aist.Properties(defaults_str=testnavio_spec)
    manager.registerFactory(profile,
                            testNavio,
                            OpenRTM_aist.Delete)	

def testNavioInit(manager):
    profile = OpenRTM_aist.Properties(defaults_str=testnavio_spec)
    manager.registerFactory(profile,
                            testNavio,
                            OpenRTM_aist.Delete)

def MyModuleInit(manager):
    testNavioInit(manager)

    # Create a component
    comp = manager.createComponent("testNavio")

def main():
    mgr = OpenRTM_aist.Manager.init(sys.argv)
    mgr.setModuleInitProc(MyModuleInit)
    mgr.activateManager()
    mgr.runManager()

if __name__ == "__main__":
    main()

